.TH frep2tf 4 "April 1993" "Scilab Group" "Scilab Function"
.so ../sci.an 
.SH NAME
frep2tf - transfer function realization from frequency response
.SH CALLING SEQUENCE
.nf
[h [,err]]=frep2tf(frq,repf,dg) 
.fi
.SH PARAMETERS
.TP 10
frq   
: vector of frequencies
.TP
repf  
: vector of frequency response
.TP
dg    
: degree of linear system
.TP
h     
: SISO transfer function 
.TP
err   
: error \fVnorm([ n(2i*pi*frq) - rep.*d(2i*pi*frq)],'fro')\fR
.SH DESCRIPTION
Frequency response to  transfer function conversion. The order of \fVh\fR
is a priori given in \fVdg\fR which must be provided.
.SH EXAMPLE
.nf
s=poly(0,'s');
h=syslin('c',(s-1)/(s^3+5*s+20))
frq=0:0.05:3;repf=repfreq(h,frq);
clean(frep2tf(frq,repf,3))
.fi
.SH SEE ALSO
imrep2ss, arl2, time_id, armax, frfit



