.TH norm 1 "April 1993" "Scilab Group" "Scilab Function"
.so ../sci.an
.SH NAME
norm - matrix norms
.SH CALLING SEQUENCE
.nf
[y]=norm(x [,flag])
.fi
.SH PARAMETERS
.TP 10
x
: vector or matrix
.TP 10
flag
: string (type of norm) (default value =2)
.SH DESCRIPTION
For matrices
.TP 15
norm(x) 
: or \fVnorm(x,2)\fR is the largest singular value of \fVx\fR.
.TP
norm(x,1) 
: l_1 norm \fVx\fR (the largest column sum). 
.TP
norm(x,'inf')  
: l_infinity norm of \fVx\fR (the largest row sum).
.TP
norm(x,'fro') 
: Frobenius norm i.e. \fVsqrt(sum(diag(x'*x)))\fR

.LP
For vectors
.TP 15
norm(v,p)
: l_p norm (\fVsum(v(i)^p))^(1/p)\fR .
.TP
norm(v) 
: \fV=norm(v,2)\fR : l_2 norm
.TP
norm(v,'inf') 
: \fVmax(abs(v(i)))\fR.
.SH EXAMPLE
.nf
A=[1,2,3];
norm(A,1)
norm(A,'inf')
A=[1,2;3,4]
max(svd(A))-norm(A)
.fi
.SH SEE ALSO
h_norm, dhnorm, h2norm
