.TH remezb 1 "April 1993" "Scilab Group" "Scilab Function"
.so ../sci.an
.SH NAME
remezb - Minimax approximation of magnitude response
.SH CALLING SEQUENCE
.nf
[an]=remezb(nc,fg,ds,wt)
.fi
.SH PARAMETERS
.TP
nc
: Number of cosine functions
.TP
fg
: Grid of frequency points in [0,.5)
.TP
ds
: Desired magnitude on grid \fVfg\fR
.TP
wt
: Weighting function on error on grid \fVfg\fR
.TP
an
: Cosine filter coefficients
.SH DESCRIPTION
Minimax approximation of a frequency domain
magnitude response. The approximation takes
the form \fVh = sum[a(n)*cos(wn)]\fR
for n=0,1,...,nc. An FIR, linear-phase filter
can be obtained from the the output of the function
by using the following commands
.nf
         hn(1:nc-1)=an(nc:-1:2)/2;
         hn(nc)=an(1);
         hn(nc+1:2*nc-1)=an(2:nc)/2;
.fi
.SH AUTHOR
C. B.
